#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const meow_1 = __importDefault(require("meow"));
const index_1 = require("./index");
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        const cli = meow_1.default(`\
Usage
  $ js2file [folder]

Options
  --outDir  where to output files to, defaults to [folder]
  --ext     resulting extension, required
  --require require file before execution

Examples
  $ js2file templates/ --outDir dist --ext html
  typescript
  $ js2file templates/ --outDir dist --ext html --require ts-node/register
  ttypescript
  $ TS_NODE_COMPILER=ttsc js2file templates/ --outDir dist --ext html --require ts-node/register
`);
        if (cli.input.length !== 1) {
            console.log("There should be one input file");
            cli.showHelp();
            process.exit(1);
            return;
        }
        if (cli.flags.ext === undefined) {
            console.log("Must specify extension");
            cli.showHelp();
            process.exit(1);
            return;
        }
        yield index_1.jsToFile(cli.input[0], cli.flags);
    });
}
main().catch(err => {
    console.error(err);
    process.exit(1);
});
