"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const util_1 = require("util");
const fs_extra_1 = require("fs-extra");
const glob_1 = __importDefault(require("glob"));
const utils_1 = require("./utils");
const glob = util_1.promisify(glob_1.default);
function runAndSave(file, outDir, ext) {
    return __awaiter(this, void 0, void 0, function* () {
        const outFile = utils_1.getResultFile(file, outDir, ext);
        const content = require(file);
        const func = typeof content === "function" ? content : content.default;
        // TODO check func is a function
        const result = func();
        // TODO check result is a string
        yield fs_extra_1.writeFile(outFile, result);
    });
}
exports.runAndSave = runAndSave;
function jsToFile(base, options) {
    return __awaiter(this, void 0, void 0, function* () {
        const { ext } = options;
        const outDir = options.outDir || base;
        if (options.require) {
            require(options.require);
        }
        const files = yield glob(path_1.resolve(base, "**/*"));
        yield fs_extra_1.ensureDir(outDir);
        for (const file of files) {
            const rel = path_1.relative(base, path_1.dirname(file));
            const dir = path_1.resolve(outDir, rel);
            yield fs_extra_1.ensureDir(dir);
            yield runAndSave(file, dir, ext);
        }
    });
}
exports.jsToFile = jsToFile;
